<?php
/**
 * @package 	formfields
 * @version		1.4
 * @created		Dec 2011
 * @author		BowThemes
 * @email		support@bowthems.com
 * @website		http://bowthemes.com
 * @support		Forum - http://bowthemes.com/forum/
 * @copyright	Copyright (C) 2011 Bowthemes. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 *
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.form.formfield');
/*
 * This trick allows us to extend the correct class, based on whether it's Joomla! 1.5 or 1.6
 */
if (!class_exists('JFakeElementBase')) {
	if (version_compare(JVERSION, '1.6.0', 'ge')) {
		class JFakeElementBase extends JFormField {
			// This line is required to keep Joomla! 1.6/1.7 from complaining
			protected function getInput() {
			}
		}
	} else {
		class JFakeElementBase extends JElement {
		}
	}
}
class JFakeElementFetchImage extends JFakeElementBase {

    protected $type = 'fetchimage';


    function fetchElement($name, $value, &$node, $control_name) {
        $id = JRequest::getInt('id', 0);
        if (!$id) {
            $cid = JRequest::getVar('cid', array(0));
            $id = $cid[0];
        }

        return $this->_build($id);
    }

    protected function getInput() {
        JHtml::_('behavior.framework', true);
        JHtml::_('behavior.modal');

        $moduleID = $this->form->getValue('id');
        if ($moduleID == '')
            $moduleID = 0;
        return $this->_build($moduleID);
    }
    protected function _build($moduleID){
        if($moduleID == '') $moduleID = 0;
        $btnGetImages = JText::_("MOD_BACKGROUNDSHOW_BUTTON_GETIMAGES");

        $uploadURL = JURI::root() . 'modules/mod_bt_backgroundslideshow/ajax.php';
        //check phocagallery component exists
        $phocaPath = JPATH_ADMINISTRATOR.'/components/com_phocagallery';
        $phocaExists = (is_dir($phocaPath)) ? 1 : 0;
        //check joomgallery component exists
        $jgalleryPath = JPATH_ADMINISTRATOR.'/components/com_joomgallery';
        $jgalleryPathExists = (is_dir($jgalleryPath)) ? 1 : 0;
        $root = JURI::root();
        $html = '<button id="btnGetImages" class="bt-ig-ac jfolder flickr picasa jgallery phocagallery">'.$btnGetImages.'</button>
                <script type= "text/javascript">
                    jQuery.noConflict();
                    jQuery(document).ready(function(){

                        var phocaExists = '.$phocaExists.';
                        var jgalleryExists = '.$jgalleryPathExists.';
                        var source = jQuery("#jform_params_source").val();
                        var fields = jQuery(".bt-ig-ac");
                        var parents = jQuery(".bt-ig-ac").parent();
                        parents.css("display", "none");
                        for(i = 0; i < fields.length; i++){
                            if(fields.eq(i).hasClass(source)){
                                fields.eq(i).parent().css("display", "");
                            }
                        }
                        jQuery("#jform_params_source").change(function(){
                            source = jQuery("#jform_params_source").val();
                            for(i = 0; i < fields.length; i++){
                                if(!fields.eq(i).hasClass(source)){
                                    fields.eq(i).parent().css("display", "none");
                                }else{
                                    fields.eq(i).parent().css("display", "");
                                }
                            }
                        });
                        //hide sync interval if sync type = none
                        if(jQuery("#jform_params_sync_type").val() == "none") jQuery("#jform_params_sync_interval").parent().hide();
                        jQuery("#jform_params_sync_type").change(function(){
                            if(jQuery(this).val() == "none") jQuery("#jform_params_sync_interval").parent().hide();
                            else jQuery("#jform_params_sync_interval").parent().show();
                        });
                        var inProgess = new Object();
                        inProgess.value = false;
                        jQuery("#btnGetImages").click(function(){
                            if(inProgess.value){
                                alert("'.JText::_('MOD_BACKGROUNDSHOW_ERROR_ON_PROGESS').'");
                            }else{


                                var cw = ch = th = tw = "";
                                if(jQuery("#jform_params_crop_image").val() == 1){
                                    cw = jQuery("#jform_params_crop_width").val();
                                    ch = jQuery("#jform_params_crop_height").val();
                                }
                                var strParams = "";
                                if(cw != "" && ch != "") strParams +="&cw="+cw+"&ch="+ch;
                                var getLimit = (jQuery("#jform_params_get_limit").val() != "") ? "&get_limit=" + jQuery("#jform_params_get_limit").val() : "" ;
                                var query = "";

                                switch (source){
                                    case "jfolder":
                                        if(jQuery("#jform_params_jfolder_path").val()!=""){
                                            query = "jFolderPath="+jQuery("#jform_params_jfolder_path").val() +strParams;
                                        }else{
                                            alert("'.JText::_("MOD_BACKGROUNDSHOW_JOOMLAFOLDER_ALERT").'");
                                            return false;
                                        }

                                        break;
                                    case "flickr":
                                        if(jQuery("#jform_params_flickr_api").val() != "" && jQuery("#jform_params_flickr_userid").val() != ""){
                                            query = "flickrUserID="+jQuery("#jform_params_flickr_userid").val() + "&flickrAPI="+jQuery("#jform_params_flickr_api").val();
                                            if(jQuery("#jform_params_flickr_photosetid").val() != 0)
                                                query+="&photosetid="+jQuery("#jform_params_flickr_photosetid").val();
                                        }else{
                                            alert("'.JText::_("MOD_BACKGROUNDSHOW_FLICKR_ALERT").'");
                                            return false;
                                        }
                                        break;
                                    case "picasa":
                                        if(jQuery("#jform_params_picasa_userid").val() !=""){
                                            query="picasaUserID=" + jQuery("#jform_params_picasa_userid").val();
                                            if(jQuery("#jform_params_picasa_albumid").val() != "0" && jQuery("#jform_params_picasa_albumid").val() != null)
                                                query+="&albumid="+jQuery("#jform_params_picasa_albumid").val();
                                        }else{
                                            alert("'.JText::_('MOD_BACKGROUNDSHOW_PICASA_ALERT').'");
                                            return false;
                                        }
                                        break;
                                    case "phocagallery":
                                        if(phocaExists == 1){
                                            if(jQuery("#jform_params_phoca_catid").val() !=""){
                                                 query="phoca_catid=" + jQuery("#jform_params_phoca_catid").val();
                                            }else{
                                                 query="phoca_catid=0";
                                            }
                                        }else{
                                            alert("'.JTEXT::_('MOD_BACKGROUNDSHOW_PHOCA_ALERT').'");
                                            return false;
                                        }
                                        break;
                                    case "jgallery":
                                        if(jgalleryExists == 1){
                                            if(jQuery("#jform_params_jgallery_catid").val() !=""){
                                                 query="jgallery_catid=" + jQuery("#jform_params_jgallery_catid").val();
                                            }else{
                                                 query="jgallery_catid=0";
                                            }
                                        }else{
                                            alert("'.JTEXT::_('MOD_BACKGROUNDSHOW_JOOMGALLERY_ALERT').'");
                                            return false;
                                        }
                                        break;
                                    default:
                                        break;
                                }
                                query = "action=get&" + query + "&feed_title="+jQuery("#jform_params_feed_title").val()+ getLimit+ "&id='.$moduleID.'";
                                inProgess.value = true;
                                jQuery.ajax({
                                    url: "'.$uploadURL.'",
                                    data: query,
                                    type: "get",
                                    beforeSend: function(){
                                        BTImageGallery.showMessage("btig-message", "Loading images... <span class=\"btig-upload-spinner\"></span>");
                                        jQuery("#btnGetImages").html("Loading...");
                                    },
                                    success: function(responseJSON){
                                            var data = jQuery.parseJSON(responseJSON);
                                            if (!data.success) {
                                                inProgess = false;
                                                jQuery("#btnGetImages").html("Get Images");
                                                BTImageGallery.showMessage("btig-message", "<b>Loading Failed</b> - " + data.message);
                                                BTImageGallery.removeLog();
                                            }
                                            else {
                                                sendRequest(jQuery.parseJSON(data.files), 0, BTImageGallery, strParams, inProgess);
                                            }

                                    },
                                    error: function(jqXHR, textStatus, errorThrown){
                                        inProgess = false;
                                        jQuery("#btnGetImages").html("Get Images");
                                        BTImageGallery.showMessage("btig-message", "Sending ajax request is failed. Check <b>ajax.php</b>, please.");
                                        BTImageGallery.removeLog();
                                    }
                                });

                            }
                            return false;
                        });
                        // for delete all images
                        jQuery("#btnDeleteAll").click(function(){
                            if(jQuery("#btig-gallery-container li").length > 0){
                                if(confirm("'.JText::_('MOD_BACKGROUNDSHOW_CONFIRM_DELETE_ALL').'")){
                                    jQuery.ajax({
                                         url: "'.$uploadURL.'",
                                         data: "action=delete&id='.$moduleID.'&file=all",
                                         type: "get",
                                         success: function(responseJSON){
                                            var data = jQuery.parseJSON(responseJSON);
                                            if(!data.success){
                                                BTImageGallery.showMessage("btig-message", "<b>Delete Failed</b> - " + data.message);
                                            }else{
                                                BTImageGallery.removeAll();
                                                BTImageGallery.showMessage("btig-message", "<b>Delete Success</b>");
                                            }
                                         },
                                         complete: function(){
                                            BTImageGallery.removeLog();
                                         },
                                         error: function(jqXHR, textStatus, errorThrown){
                                            BTImageGallery.showMessage("btig-message", "Sending ajax request is failed. Check <b>ajax.php</b>, please.");
                                            BTImageGallery.removeLog();
                                        }
                                    });
                                }
                            }
                            return false;
                        });
                        //ajax load photosets for flickr
                        var flickrAPI = jQuery("#jform_params_flickr_api").val();
                        var flickrUserID = jQuery("#jform_params_flickr_userid").val();
                        var slcFlickrPhotoset = jQuery("#jform_params_flickr_photosetid");
                        if(flickrAPI != "" && flickrUserID != ""){
                            getFlickrPhotoSet(slcFlickrPhotoset, flickrAPI, flickrUserID, BTImageGallery);
                        }
                        jQuery("#jform_params_flickr_userid").focus(function(){
                            flickrUserID = jQuery(this).val();
                            flickrAPI = jQuery("#jform_params_flickr_api").val();
                        }).focusout(function(){
                            if(jQuery(this).val() != flickrUserID && flickrAPI != ""){
                                getFlickrPhotoSet(slcFlickrPhotoset, flickrAPI, jQuery(this).val(), BTImageGallery);
                            }
                        });
                        jQuery("#jform_params_flickr_api").focus(function(){
                            flickrAPI = jQuery(this).val();
                            flickrUserID = jQuery("#jform_params_flickr_userid").val();
                        }).focusout(function(){
                            if(jQuery(this).val() != flickrAPI && flickrUserID != ""){
                                getFlickrPhotoSet(slcFlickrPhotoset, jQuery(this).val(),flickrUserID, BTImageGallery);
                            }
                        });
                        //ajax load album for picasa
                        var picasaUserID = jQuery("#jform_params_picasa_userid").val();
                        var slcPicasaAlbum = jQuery("#jform_params_picasa_albumid");
                        if(picasaUserID != ""){
                            getPicasaAlbums(slcPicasaAlbum, picasaUserID, BTImageGallery);
                        }
                        jQuery("#jform_params_picasa_userid").focus(function(){
                            picasaUserID = jQuery(this).val();
                        }).focusout(function(){
                            if(jQuery(this).val() != picasaUserID){
                                getPicasaAlbums(slcPicasaAlbum, jQuery(this).val(), BTImageGallery);
                            }
                        });

                    });
                    function sendRequest(files, i, BTImageGallery, strParams, inProgess){
                        if(i < files.length){
                            jQuery.ajax({
                                url: "'.$uploadURL.'",
                                data: "action=upload&id='.$moduleID.'&btfile="+ files[i].file + "&title="+files[i].title + "&source="+files[i].source+ strParams,
                                type: "get",
                                beforeSend: function(){
                                    //if(jQuery("#btig-upload-list").css("display") == "none") jQuery("#btig-upload-list").css("display", "");
                                    var j;
                                    for(j = files[i].file.length - 1; j >= 0; j--){
                                        if(files[i].file.charAt(j) == \'/\' || files[i].file.indexOf(j) == \'\\\\\') break;
                                    }

                                    var filename = files[i].file.substr(j+1);
                                    BTImageGallery.showMessage("btig-message", "<div id=\"btig-upload-file-" + i + "\">Loading <b>" + filename + "</b><span class=\"btig-upload-spinner\"></span></div>");

                                },
                                success: function(response){
                                    var data2 = jQuery.parseJSON(response);
                                    if(data2 == null){
                                        BTImageGallery.showMessage("btig-message", "<b>Loading Failed</b> - Have errors");
                                        BTImageGallery.removeLog();
                                    }else{
                                        var file = data2.files;
                                        jQuery("#btig-upload-file-"+i+" .btig-upload-spinner").remove();
                                        if (!data2.success) {
                                            jQuery("#btig-upload-file-"+i).append("<span style=\"color: red;\"> " + data2.message +"</span>");
                                        }
                                        else {

                                            var item = {
                                                  file: file.filename,
                                                  title: file.title,
                                                  desc: file.desc
                                            };
                                            BTImageGallery.add(item);
                                            jQuery("#btig-upload-file-"+i).append("<span style=\"color: green;\"> Completed</span>");
                                        }
                                   }
                                  sendRequest(files, ++i, BTImageGallery, strParams, inProgess);
                                },
                                error: function(jqXHR, textStatus, errorThrown){
                                        BTImageGallery.showMessage("btig-message", "Sending ajax request is failed. Check <b>ajax.php</b>, please.");
                                        BTImageGallery.removeLog();
                                    }
                            });
                        }else{
                            BTImageGallery.removeLog();
                            inProgess.value = false;
                            jQuery("#btnGetImages").html("Get Images").removeAttr("disabled");
                            return;
                        }
                    }
                    function getFlickrPhotoSet(select, api, userid, BTImageGallery){
                        //remove old option
                        var options = select.children();
                        for(var i = 0; i < options.length; i++){
                            options.eq(i).remove();
                        }
                        select.trigger("liszt:updated");
                        jQuery.ajax({
                            url: "'.$uploadURL.'",
                            type: "get",
                            data: "action=load_options&flickrAPI="+ api + "&flickrUserID=" + userid,
                            beforeSend: function(){
                                BTImageGallery.showMessage("btig-message", "<div>Loading Flickr Photosets <span class=\"btig-upload-spinner\"></span></div>");
                                jQuery("#btnGetImages").html("Loading...").attr("disabled","disabled");
                            },
                            success: function(response){
                                var data = jQuery.parseJSON(response);
                                if(data != null && data.success){
                                    if(data.options.length > 0){
                                        for(var i = 0; i< data.options.length; i++){
                                            select.append("<option value=\""+data.options[i].value+"\">"+data.options[i].text+"</option>");
                                        }
                                        select.trigger("liszt:updated");
                                    }else{
                                        BTImageGallery.showMessage("btig-message", "<div>Have no photoset.</div>");
                                    }
                                }else{
                                    BTImageGallery.showMessage("btig-message", "<div>Loading Flickr Photosets failed. "+ data.message + "</div>");
                                }
                                BTImageGallery.removeLog();
                                jQuery("#btnGetImages").html("Get Images").removeAttr("disabled");

                            },
                            error: function(jqXHR, textStatus, errorThrown){
                                        jQuery("#btnGetImages").html("Get Images");
                                        BTImageGallery.showMessage("btig-message", "Sending ajax request is failed. Check <b>ajax.php</b>, please.");
                                        BTImageGallery.removeLog();
                                    }
                        });
                    }
                    function getPicasaAlbums(select, userid, BTImageGallery){
                        //remove old option
                        var options = select.children();
                        for(var i = 0; i < options.length; i++){
                            options.eq(i).remove();
                        }
                        select.trigger("liszt:updated");
                        jQuery.ajax({
                            url: "'.$uploadURL.'",
                            type: "get",
                            data: "action=load_options&picasaUserID="+ userid,
                            beforeSend: function(){
                                BTImageGallery.showMessage("btig-message", "<div>Loading Picasa albums <span class=\"btig-upload-spinner\"></span></div>");
                                jQuery("#btnGetImages").html("Loading...").attr("disabled","disabled");
                            },
                            success: function(response){
                                var data = jQuery.parseJSON(response);
                                if(data != null && data.success){
                                    if(data.options.length > 0){
                                        for(var i = 0; i< data.options.length; i++){
                                            select.append("<option value=\""+data.options[i].value+"\">"+data.options[i].text+"</option>");
                                        }
                                        select.trigger("liszt:updated");
                                    }else{
                                        BTImageGallery.showMessage("btig-message", "<div>Have no album.</div>");
                                    }
                                }else{
                                    BTImageGallery.showMessage("btig-message", "<div>Loading Picasa albums failed. "+ data.message + "</div>");
                                }
                                BTImageGallery.removeLog();
                                jQuery("#btnGetImages").html("Get Images").removeAttr("disabled");
                            },
                            error: function(jqXHR, textStatus, errorThrown){
                                        jQuery("#btnGetImages").html("Get Images");
                                        BTImageGallery.showMessage("btig-message", "Sending ajax request is failed. Check <b>ajax.php</b>, please.");
                                        BTImageGallery.removeLog();
                                    }
                        });
                    }
                </script>';

		return $html;
    }
}
/*
 * Part two of our trick; we define the proper element name, depending on whether it's Joomla! 1.5 or 1.6
 */
if (version_compare(JVERSION, '1.6.0', 'ge')) {
	class JFormFieldFetchImage extends JFakeElementFetchImage {
	}
} else {
	class JElementFetchImage extends JFakeElementFetchImage {
	}
}
?>
