<?php

/**
 * @package 	formfields
 * @version		1.4
 * @created		Dec 2011
 * @author		BowThemes
 * @email		support@bowthems.com
 * @website		http://bowthemes.com
 * @support		Forum - http://bowthemes.com/forum/
 * @copyright	Copyright (C) 2011 Bowthemes. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 *
 */
// No direct access
defined('_JEXEC') or die;
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

/*
 * This trick allows us to extend the correct class, based on whether it's Joomla! 1.5 or 1.6
 */
if (!class_exists('JFakeElementBase')) {
	if (version_compare(JVERSION, '1.6.0', 'ge')) {
		class JFakeElementBase extends JFormField {
			// This line is required to keep Joomla! 1.6/1.7 from complaining
			protected function getInput() {
			}
		}
	} else {
		class JFakeElementBase extends JElement {
		}
	}
}

class JFakeElementGallery extends JFakeElementBase {

	protected $type = 'gallery';
	public $_name = 'gallery';

	protected function getLabel() {
		return '';
	}

	function fetchElement($name, $value, &$node, $control_name) {
		$id = JRequest::getInt('id', 0);
		if (!$id) {
			$cid = JRequest::getVar('cid', array(0));
			$id = $cid[0];
		}
            
		return $this->_build($id, 'params['.$name.']', $value);
	}

	protected function _build($moduleID, $name, $value) {
		/* @var JDocument $document */
		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::root() . "modules/mod_bt_backgroundslideshow/assets/css/btimagegallery.css");

		if (version_compare(JVERSION, '1.6.0', 'ge')) {
			$document->addScript(JURI::root() . "modules/mod_bt_backgroundslideshow/assets/js/btimagegallery.min.js");
			$document->addScript(JURI::root() . "modules/mod_bt_backgroundslideshow/assets/js/btbase64.min.js");
			?>
			<script>
			window.addEvent('domready', function() {
				initGallery();
			});
			</script>
			<?php
		}
		else {
			$document->addScript(JURI::root() . "modules/mod_bt_backgroundslideshow/assets/js/btloader.min.js");
			// Hack, replace mootools by newer
			foreach ($document->_scripts as $key => $tmp) {
				if (preg_match('#media/system/js/mootools.js#is', $key)) {
					unset($document->_scripts[$key]);
				}
			}
			$mootools = array(
			    JURI::root() . "modules/mod_bt_backgroundslideshow/assets/js/mootools-core.js" => 'text/javascript',
			    JURI::root() . "modules/mod_bt_backgroundslideshow/assets/js/mootools-more.js" => 'text/javascript'
			);
			$document->_scripts = $mootools + $document->_scripts;
			?>
			<script>

			(function(){
				var libs = [
							'<?php echo JURI::root(); ?>modules/mod_bt_backgroundslideshow/assets/js/mootools-core.js',
							'<?php echo JURI::root(); ?>modules/mod_bt_backgroundslideshow/assets/js/mootools-more.js',
							'<?php echo JURI::root(); ?>modules/mod_bt_backgroundslideshow/assets/js/btimagegallery.min.js',
							'<?php echo JURI::root(); ?>modules/mod_bt_backgroundslideshow/assets/js/btbase64.min.js',
							'<?php echo JURI::root(); ?>modules/mod_bt_backgroundslideshow/assets/squeezebox/squeezebox.min.js'
				];

				BT.Loader.js(libs, function(){
					initGallery();
				});
				BT.Loader.css('<?php echo JURI::root(); ?>modules/mod_bt_backgroundslideshow/assets/squeezebox/assets/squeezebox.css');

				window.addEvent('load', function() {
					document.combobox = null;
					var combobox = new JCombobox();
					document.combobox = combobox;
				});

			})();
			</script>
			<?php
		}



		// Remove temp files
		$items = json_decode(base64_decode($value));
            
		require_once (JPATH_ROOT . '/modules/mod_bt_backgroundslideshow/helpers/files.php');
		BTFilesHelper::cleanFiles($items, $moduleID);

            //check if 0 folder exists
            $saveDir = JPATH_SITE . '/modules/mod_bt_backgroundslideshow/images';
            if($moduleID != 0 && JFolder::exists($saveDir.'/0')){
                JFolder::move($saveDir.'/0', $saveDir.'/'.$moduleID);
            }

            //load file if miss save
            $originalDir = $saveDir . '/'. $moduleID.'/original';
            if(is_dir($originalDir)){
                $open = opendir($originalDir);
                $arrFiles = array();
                $filename = readdir($open);
                while($filename !== false){
                    //check validated file
                    if(filetype($originalDir.'/'. $filename) == "file"){
                        $existed = false;
                        if(count($items) > 0){
                            foreach($items as $item){
                                if($item->file == $filename){
                                    $existed = true;
                                    break;
                                }
                            }
                        }
                        if(!$existed){
                            $objFile = new stdClass();
                            $objFile->file = $filename;
                            $objFile->title = '';
                            $items[] = $objFile;
                        }
                    }
                    $filename = readdir($open);
                }
            }
            $value = base64_encode(json_encode($items));
            
		$html = '
			<div id="btig-message" class="clearfix"></div>
                  <ul id="btig-upload-list"></ul>
			<div id="btig-file-uploader">
				<noscript>
					<p>' . JText::_('MOD_BACKGROUNDSHOW_NOTICE_JAVASCRIPT') . '</p>
				</noscript>
			</div>
			<input id="btig-gallery-hidden" type="hidden" name="' . $name. '" value="" />
			<ul id="btig-gallery-container" class="clearfix"></ul>
			';

		?>
		<script>
		function initGallery() {
			BTImageGallery = new BT.ImageGallery({
				liveUrl: '<?php echo JURI::root(); ?>',
				encodedItems: '<?php echo $value; ?>',
				moduleID: '<?php echo $moduleID; ?>',
				galleryContainer: 'btig-gallery-container',
				dialogTemplate:
					'<fieldset class="adminform">' +
						'<ul class="adminformlist">' +
							'<li>' +
								'<label id="btig-title-lbl" class="hasTip" title="<?php echo JText::_('MOD_BACKGROUNDSHOW_FIELD_TITLE_DESC');?>" for="btig-title"><?php echo JText::_('MOD_BACKGROUNDSHOW_FIELD_TITLE_LABEL');?></label>' +
								'<input id="btig-title" type="text" name="btig-title" size="70" />' +
							'</li>' +
						'</ul>' +
					'</fieldset>' +
					'<button class="btig-dialog-ok" style="margin-left: 10px;"><?php echo JText::_('MOD_BACKGROUNDSHOW_BTN_OK');?></button><button class="btig-dialog-cancel" style="margin-left: 10px;"><?php echo JText::_('MOD_BACKGROUNDSHOW_BTN_CANCEL');?></button>'
			});

			
		};
		</script>
		<?php
		return $html;
	}


	protected function getInput() {
		JHtml::_('behavior.framework', true);
		JHtml::_('behavior.modal');

		$moduleID = $this->form->getValue('id');
            if($moduleID == '') $moduleID = 0;
		return $this->_build($moduleID, $this->name, $this->value);
	}
}

/*
 * Part two of our trick; we define the proper element name, depending on whether it's Joomla! 1.5 or 1.6
 */
if (version_compare(JVERSION, '1.6.0', 'ge')) {
	class JFormFieldGallery extends JFakeElementGallery {
	}
} else {
	class JElementGallery extends JFakeElementGallery {
	}
}
?>